//============================================================================
// Name        : hstep.c
// Author      :
// Version     :
// Copyright   : Copyright (c) 2014 by Mehdi Alizadeh
// Description :
//============================================================================

#include "BA.h"
//#include "liblinear-1.94/linear.h"
#include "sgd-2.1/svm/svmsgd.h"

void Herror(biguint *hX, biguint *Z, double *Herr, long int N, int L)
{
	long int i;
	(*Herr) = 0;
	for (i = 0; i < N; i++)
		(*Herr) += bui_fasthamming(&(hX[i]), &(Z[i]));
}

void HinitSGD(int Dx, int L)
{
	double lambda = 1e-5;
	InitializeSVM(Dx, L, lambda);
}

void HtrainSGD(intype *X, biguint *Z, long int N, int Dx, int chunks, int epochs, int isvm, int stepcounter, int *minibatchperm)
{
	int i, ichunk, iepoch;

	long int begins[chunks];
	long int lens[chunks];

	long int ibegin = 0;
	for (ichunk = 0; ichunk < chunks; ichunk++)
	{
		long int ilen = (N - ibegin) / (chunks - ichunk);

		begins[ichunk] = ibegin;
		lens[ichunk] = ilen;

		ibegin += ilen;
	}

	for (iepoch = 0; iepoch < epochs; iepoch++)
	{
		for (i = 0; i < chunks; i++)
		{
			ichunk = minibatchperm[i];

			if (lens[ichunk] == 0)
				continue;

			TrainSVM(X, Z, Dx, begins[ichunk], begins[ichunk] + lens[ichunk] - 1, isvm, stepcounter * chunks + i);
		}
	}
}

void HforwardSGD(intype *X, biguint *hX, long int N, int L, int Dx)
{
	int bit;
	long int j;
	for (j = 0; j < N; j++)
		for (bit = 0; bit < L; bit++)
			bui_setbit(&(hX[j]), bit, PredictSVM(bit, &(X[j * Dx]), Dx));
}

void getHmodel(int isvm, double *buffer, int *index)
{
	GetSVM(isvm, buffer, index);
}

void setHmodel(int isvm, double *buffer, int *index)
{
	SetSVM(isvm, buffer, index);
}

